C     Soluo do quinto exerccio da Lista de Exerccios 2. O programa
C     l o nome e as 3 notas dos 5 alunos pertencentes a cada uma das
C     3 turmas do curso. Ao final, ele permite que o usurio faa
C     consultas sobre os dados lidos. As consultas podem ser por na
C     mdia de um aluno cujo nome foi informado, ou nos nomes dos alunos
C     com mdia superior a uma determinado valor informado.
      program list2ex5
      
C     Declarao de parmetros.
      integer NumTurmas, NumAlunos, NumProvas
      parameter (NumTurmas = 3, NumAlunos = 5, NumProvas = 3)
      
      integer OPCAO_NULA, OPCAO_NOME, OPCAO_NOTA, OPCAO_SAIR
      parameter (OPCAO_NULA = 0, OPCAO_NOME = 1,
     >                                   OPCAO_NOTA = 2, OPCAO_SAIR = 3)
      
C     Declarao de variveis.
      character*30 Nomes(NumTurmas,NumAlunos), NomeConsulta
      real Notas(NumTurmas,NumAlunos,NumProvas)
      real Medias(NumTurmas,NumAlunos), MediaConsulta
      integer iTurma, iAluno, iProva, Opcao
      logical NaoEncontrado

C     Ler nomes dos alunos.
11    format(/,'Informe o nome dos alunos da Turma ',I1)
12    format(  '  Aluno ',I1,': ',$)

      do iTurma = 1, NumTurmas
        print 11, iTurma
        
        do iAluno = 1, NumAlunos
          print 12, iAluno
          read *, Nomes(iTurma,iAluno)
        end do
        
      end do
      
C     Ler notas dos alunos nas provas.
21    format(/,'Informe as notas dos alunos para a Turma ',I1,$)
22    format(/,'  Aluno ',I1,': ',A30)
23    format(  '  Prova ',I1,': ',$)
24    format(  '  Nota invlida! Prova ',I1,'.: ',$)

      do iTurma = 1, NumTurmas
        print 21, iTurma

        do iAluno = 1, NumAlunos
           print 22, iAluno, Nomes(iTurma,iAluno)
           
           do iProva = 1, NumProvas
              print 23, iProva
              read *, Notas(iTurma,iAluno,iProva)
              do while ((Notas(iTurma,iAluno,iProva) .lt. 0.0)
     >                     .or. (10.0 .lt. Notas(iTurma,iAluno,iProva)))
                print 24, iProva
                read *, Notas(iTurma,iAluno,iProva)
              end do
           
           end do

        end do

      end do
      
C     Calcular mdias.
      do iTurma = 1, NumTurmas
        do iAluno = 1, NumAlunos

          Medias(iTurma,iAluno) = 0.0
          do iProva = 1, NumProvas
            Medias(iTurma,iAluno) = Medias(iTurma,iAluno)
     >                                     + Notas(iTurma,iAluno,iProva)
          end do
          Medias(iTurma,iAluno) = Medias(iTurma,iAluno) / NumProvas
        
        end do
      end do
      
C     Realizar consultas sobre os dados lidos.
31    format(/,'Escolha (',I1,') para consultar mdia por nome',
     >       /,'        (',I1,') para consultar nomes por mdia mnima',
     >       /,'        (',I1,') para sair',
     >       /,
     >       /,'Opo: ',$)
     
41    format(/,'Informe o nome do aluno:',A1,$)
42    format(  '  A mdia do aluno  ',F4.1,' (Turma ',I1,').')
43    format(  '  O aluno informado no foi encontrado!',A1)

51    format(/,'Informe a menor mdia de interesse:',A1,$)
52    format(  '  Turma ',I1,', Mdia ',F4.1,': ',A30)
53    format(  '  Nenhum aluno com mdia maior que ',F4.1,
     >                                               ' foi encontrado.')

      Opcao = OPCAO_NULA
      do while (Opcao .ne. OPCAO_SAIR)

        Opcao = OPCAO_NULA
        do while ((Opcao .ne. OPCAO_NOME) .and. (Opcao .ne. OPCAO_NOTA)
     >                                    .and. (Opcao .ne. OPCAO_SAIR))
           print 31, OPCAO_NOME, OPCAO_NOTA, OPCAO_SAIR
           read *, Opcao
        end do
        
C       Consultar por nome.
        if (Opcao .eq. OPCAO_NOME) then
          print 41, ' '
          read *, NomeConsulta
          
          NaoEncontrado = .true.
          do iTurma = 1, NumTurmas
            do iAluno = 1, NumAlunos
              if (NomeConsulta .eq. Nomes(iTurma,iAluno)) then
                print 42, Medias(iTurma,iAluno), iTurma
                NaoEncontrado = .false.
              end if
            end do
          end do

          if (NaoEncontrado) then
            print 43, ' '
          end if

        end if
        
C       Consultar por nota.
        if (Opcao .eq. OPCAO_NOTA) then
          print 51, ' '
          read *, MediaConsulta
          
          NaoEncontrado = .true.
          do iTurma = 1, NumTurmas
            do iAluno = 1, NumAlunos
              if (MediaConsulta .lt. Medias(iTurma,iAluno)) then
                print 52, iTurma, Medias(iTurma,iAluno),
     >                                              Nomes(iTurma,iAluno)
                NaoEncontrado = .false.
              end if
            end do
          end do
          
          if (NaoEncontrado) then
            print 53, MediaConsulta
          end if
          
        end if
      end do

      end
